SystemOrganization addCategory: #Reflectogram!
SystemOrganization addCategory: 'Reflectogram-Benchmarks'!
SystemOrganization addCategory: 'Reflectogram-Case-Study'!
SystemOrganization addCategory: 'Reflectogram-Conditions-Actions'!
SystemOrganization addCategory: 'Reflectogram-Events'!
SystemOrganization addCategory: 'Reflectogram-Graph-Points'!
SystemOrganization addCategory: 'Reflectogram-Modes'!
SystemOrganization addCategory: 'Reflectogram-Targets'!
SystemOrganization addCategory: 'Reflectogram-Tests'!

TestCase subclass: #EventTest
	instanceVariableNames: 'link'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Tests'!

!EventTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 15:02'!
event

	^ Event new
! !

!EventTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 12:34'!
expectedResultFor: aMethod

	|testObj result|
	
	testObj := self testObjectFor: aMethod.
	[ result := testObj perform: aMethod selector withEnoughArguments: { }] on: Exception do: [:ex | result := ex  ].
	
	^ result! !

!EventTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 14:40'!
methods

	^ { }! !

!EventTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/19/2015 14:27'!
newLinkWith: aBlock

	^ MetaLink new
		metaObject: aBlock;
		selector: #value;
		control: #instead;
		options: #(+ optionCompileOnLinkInstallation).! !

!EventTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/4/2015 16:20'!
tearDown

	"additonal clean up"	
	
	link ifNotNilDo: [:l | l uninstall].
	self methods do: [:method | method recompile].	 "clean up and revert method to match each source-code"
	super tearDown.! !

!EventTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/6/2015 10:59'!
testEvent

	| expectedResult reflectiveResult metaJumpOccured |
	self methods do: [:method |
		expectedResult := self expectedResultFor: method.
		link := self newLinkWith: [metaJumpOccured := true].  
		self event 
			annotateMethod: method
			withLink: link.
			reflectiveResult := self expectedResultFor: method.
			link uninstall.
			method recompile.	"clean up and revert method to match each source-code"
			self assert: metaJumpOccured = true. "some events like sends may be triggered more than once"
			self assert: (expectedResult class = reflectiveResult class).
	]! !

!EventTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/7/2015 15:12'!
testObjectFor: aMethod
	|testObj|
	testObj := nil.
	"these do not respond to new"
	aMethod methodClass = SmalltalkImage ifTrue: [ testObj := SmalltalkImage current ].
	aMethod methodClass = SmallInteger ifTrue: [ testObj := 3 ]. 
	aMethod methodClass = Symbol ifTrue: [ testObj := #meh ].
	"proto-object does not know perform:withEnoughArgs"
	aMethod methodClass = ProtoObject ifTrue: [ testObj := Object new ]. 
	aMethod methodClass isMeta ifTrue: [ testObj := aMethod methodClass soleInstance ].
	testObj ifNil: [ testObj := aMethod methodClass new ]. 
	
	^ testObj! !

EventTest subclass: #GlobalReadTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Tests'!

!GlobalReadTest commentStamp: '<historical>' prior: 0!
A GlobalReadTest is a test class for testing the behavior of GlobalRead!

!GlobalReadTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 14:08'!
event

	^ GlobalRead new! !

!GlobalReadTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 14:32'!
methods

	^ {DummyEventTestingClass>>#globalRead}! !

!GlobalReadTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/7/2015 12:11'!
newLinkWith: aBlock

	"example of mix explicit and lazy reification (all three context / class / object reifications are found at runtime)
	but name is passed by the re-compilation process -- note here that name is known at installation time so can be hardwired
	instead of passed"

	^ MetaLink new
		metaObject: [:name | aBlock value. (thisContext sender receiver class bindingOf: name) value  ];
		selector: #value:;
		control: #instead;
		arguments: #(name);
		options: #(+ optionCompileOnLinkInstallation).! !

EventTest subclass: #IVReadTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Tests'!

!IVReadTest commentStamp: '<historical>' prior: 0!
An IVReadTest is a test class for testing the behavior of IVRead!

!IVReadTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 14:58'!
event

	^ IVRead new! !

!IVReadTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 15:01'!
methods

	^ { DummyEventTestingClass>>#readIV }! !

!IVReadTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/7/2015 12:09'!
newLinkWith: aBlock

	^ MetaLink new
		metaObject: [:name | aBlock value. thisContext sender receiver instVarNamed: name  ];
		selector: #value:;
		control: #instead;
		arguments: #(name);
		options: #(+ optionCompileOnLinkInstallation).! !

EventTest subclass: #IVWriteTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Tests'!

!IVWriteTest commentStamp: '<historical>' prior: 0!
An IVWriteTest is a test class for testing the behavior of IVWrite!

!IVWriteTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 15:02'!
event
	
	^ IVWrite new! !

!IVWriteTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 15:03'!
methods

	^ { DummyEventTestingClass>>#writeIV }! !

!IVWriteTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/7/2015 12:14'!
newLinkWith: aBlock

	^ MetaLink new
		metaObject: [:name :newValue | aBlock value. thisContext sender receiver instVarNamed: name put: newValue  ];
		selector: #value:value:;
		control: #instead;
		arguments: #(name newValue);
		options: #(+ optionCompileOnLinkInstallation).! !

EventTest subclass: #LiteralReadTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Tests'!

!LiteralReadTest commentStamp: '<historical>' prior: 0!
A LiteralReadTest is a test class for testing the behavior of LiteralRead!

!LiteralReadTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 15:04'!
event
	^ LiteralRead new! !

!LiteralReadTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 15:05'!
methods

	^ { DummyEventTestingClass>>#literalRead }! !

!LiteralReadTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/7/2015 12:35'!
newLinkWith: aBlock

	^ MetaLink new
		metaObject: [:node | aBlock value. node value  ];
		selector: #value:;
		control: #instead;
		arguments: #(node);
		options: #(+ optionCompileOnLinkInstallation).! !

EventTest subclass: #MSGReceiveTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Tests'!

!MSGReceiveTest commentStamp: '<historical>' prior: 0!
A MSGReceiveTest is a test class for testing the behavior of MSGReceive!

!MSGReceiveTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 15:07'!
event

	^ MSGReceive new! !

!MSGReceiveTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 15:07'!
methods

	^ { DummyEventTestingClass>>#msgReceive }! !

!MSGReceiveTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/9/2015 12:16'!
newLinkWith: aBlock

	^ MetaLink new
		metaObject: [:theNode :theLink | 
			|context initialMethod|
			context := thisContext sender.
			aBlock value .
			theLink uninstall.
			initialMethod := context method methodClass >> context method selector.  
			initialMethod  valueWithReceiver: context receiver arguments: context arguments.  
			theNode link: theLink.
		];
		selector: #value:value:;
		control: #instead;
		arguments: #(node link);
		options: #(+ optionCompileOnLinkInstallation).! !

EventTest subclass: #MSGSendTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Tests'!

!MSGSendTest commentStamp: '<historical>' prior: 0!
A MSGSendTest is a test class for testing the behavior of MSGSend!

!MSGSendTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 15:08'!
event

	^ MSGSend new! !

!MSGSendTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/21/2015 12:23'!
methods

	^ { DummyEventTestingClass>>#msgSend }! !

!MSGSendTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/7/2015 15:19'!
newLinkWith: aBlock

	^ MetaLink new
		metaObject: [:receiver :selector :arguments | aBlock value. receiver perform: selector withArguments: arguments  ];
		selector: #value:value:value:;
		control: #instead;
		arguments: #(receiver selector arguments);
		options: #(+ optionCompileOnLinkInstallation).! !

EventTest subclass: #MethodExecutionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Tests'!

!MethodExecutionTest commentStamp: '<historical>' prior: 0!
A MethodExecutionTest is a test class for testing the behavior of MethodExecution!

!MethodExecutionTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 15:56'!
event

	^ MethodExecution new! !

!MethodExecutionTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 15:58'!
methods

	^ { DummyEventTestingClass>>#methodExecution }! !

!MethodExecutionTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/9/2015 12:19'!
newLinkWith: aBlock

	^ MetaLink new
		metaObject: [:theNode :theLink | 
			|context initialMethod|
			context := thisContext sender.
			aBlock value .
			theLink uninstall.
			initialMethod := context method methodClass >> context method selector.  
			initialMethod  valueWithReceiver: context receiver arguments: context arguments.  
			theNode link: theLink.
		];
		selector: #value:value:;
		control: #instead;
		arguments: #(node link);
		options: #(+ optionCompileOnLinkInstallation).! !

EventTest subclass: #ObjectCreationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Tests'!

!ObjectCreationTest commentStamp: '<historical>' prior: 0!
An ObjectCreationTest is a test class for testing the behavior of ObjectCreation!

!ObjectCreationTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 16:02'!
event

	^ ObjectCreation new! !

!ObjectCreationTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/7/2015 14:35'!
methods

	^ { DummyEventTestingClass class>>#new }! !

!ObjectCreationTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/9/2015 12:19'!
newLinkWith: aBlock

	^ MetaLink new
		metaObject: [:theNode :theLink | 
			|context initialMethod|
			context := thisContext sender.
			aBlock value .
			theLink uninstall.
			initialMethod := context method methodClass >> context method selector.  
			initialMethod  valueWithReceiver: context receiver arguments: context arguments.  
			theNode link: theLink.
		];
		selector: #value:;
		control: #instead;
		arguments: #(node link);
		options: #(+ optionCompileOnLinkInstallation).! !

EventTest subclass: #PassedAsArgTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Tests'!

!PassedAsArgTest commentStamp: '<historical>' prior: 0!
A PassedAsArgTest is a test class for testing the behavior of PassedAsArg!

!PassedAsArgTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 17:02'!
event

	^ PassedAsArg new! !

!PassedAsArgTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/6/2015 11:01'!
methods

	^ { DummyEventTestingClass>>#passedAsArg }! !

!PassedAsArgTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/19/2015 15:12'!
newLinkWith: aBlock

	^ MetaLink new
		metaObject: [:receiver :selector :arguments | aBlock value. 
			"normally checking the args here for the one you are looking"

			Transcript show: receiver; cr; show: selector; cr; show: arguments; cr.
			receiver perform: selector withArguments: arguments ];
		selector: #value:value:value:;
		control: #instead;
		arguments: #(receiver selector arguments);
		options: #(+ optionCompileOnLinkInstallation).! !

EventTest subclass: #ReturnTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Tests'!

!ReturnTest commentStamp: '<historical>' prior: 0!
A ReturnTest is a test class for testing the behavior of Return!

!ReturnTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 17:00'!
event

	^ Return new! !

!ReturnTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 17:01'!
methods

	^ { DummyEventTestingClass>>#return }! !

!ReturnTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/7/2015 16:26'!
newLinkWith: aBlock

	^ MetaLink new
		metaObject: [:value | aBlock value. thisContext sender return: value ]; "does not work at the moment"
		selector: #value:;
		control: #instead;
		arguments: #(value);
		options: #(+ optionCompileOnLinkInstallation).! !

EventTest subclass: #ReturnedTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Tests'!

!ReturnedTest commentStamp: '<historical>' prior: 0!
A ReturnedTest is a test class for testing the behavior of Returned!

!ReturnedTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 17:00'!
event

	^ Return new! !

!ReturnedTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 17:00'!
methods

	^ { DummyEventTestingClass>>#returned: }! !

!ReturnedTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/7/2015 16:27'!
newLinkWith: aBlock

	^ MetaLink new
		metaObject: [:value | aBlock value. thisContext sender return: value ]; "does not work at the moment -- here you 'll normally check for the object"
		selector: #value:;
		control: #instead;
		arguments: #(value);
		options: #(+ optionCompileOnLinkInstallation).! !

EventTest subclass: #StoredTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Tests'!

!StoredTest commentStamp: '<historical>' prior: 0!
A StoredTest is a test class for testing the behavior of Stored!

!StoredTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 16:59'!
event
	
	^ Stored new! !

!StoredTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 16:59'!
methods

	^ { DummyEventTestingClass>>#stored: } ! !

!StoredTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/7/2015 16:34'!
newLinkWith: aBlock

	^ MetaLink new
		metaObject: [:node :name :newValue | aBlock value. 
			node variable class = RBInstanceVariableNode "this is where we will check for the obj
			in question"
				ifTrue: [thisContext sender receiver instVarNamed: name put: newValue]  
				ifFalse: [ thisContext sender tempNamed: name put: newValue ] "temporary"
		];
		selector: #value:value:value:;
		control: #instead;
		arguments: #(node name newValue);
		options: #(+ optionCompileOnLinkInstallation).! !

EventTest subclass: #TempReadTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Tests'!

!TempReadTest commentStamp: '<historical>' prior: 0!
A TempReadTest is a test class for testing the behavior of TempRead!

!TempReadTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 16:57'!
event

	^ TempRead new! !

!TempReadTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 16:57'!
methods

	^ { DummyEventTestingClass>>#tempRead }! !

!TempReadTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/7/2015 17:11'!
newLinkWith: aBlock

	^ MetaLink new
		metaObject: [:name | aBlock value. thisContext sender tempNamed: name  ];
		selector: #value:;
		control: #instead;
		arguments: #(name);
		options: #(+ optionCompileOnLinkInstallation).! !

EventTest subclass: #TempWriteTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Tests'!

!TempWriteTest commentStamp: '<historical>' prior: 0!
A TempStoreTest is a test class for testing the behavior of TempStore!

!TempWriteTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 16:42'!
event
	^ TempWrite new! !

!TempWriteTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 16:56'!
methods

	^ { DummyEventTestingClass>>#tempWrite }! !

!TempWriteTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/7/2015 16:34'!
newLinkWith: aBlock

	^ MetaLink new
		metaObject: [:name :newValue | aBlock value. thisContext sender tempNamed: name put: newValue  ];
		selector: #value:value:;
		control: #instead;
		arguments: #(name newValue);
		options: #(+ optionCompileOnLinkInstallation).! !

Object subclass: #BenchAll
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Benchmarks'!

Object subclass: #DummyEventTestingClass
	instanceVariableNames: 'anIv'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Tests'!

!DummyEventTestingClass class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/7/2015 14:35'!
new

	"intresting here that you should either add new if it does not exist
	or intercess it in the superclass using a framework condition"

	^ super new! !

!DummyEventTestingClass methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/7/2015 12:45'!
bar

	^ 3! !

!DummyEventTestingClass methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/4/2015 11:04'!
foo! !

!DummyEventTestingClass methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/4/2015 11:07'!
foo: anArgument! !

!DummyEventTestingClass methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/4/2015 11:54'!
globalRead

	^ Object! !

!DummyEventTestingClass methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/7/2015 12:15'!
initialize
	

	anIv = 42! !

!DummyEventTestingClass methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/4/2015 11:04'!
ipsum! !

!DummyEventTestingClass methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/7/2015 12:57'!
literalRead

	^ 3! !

!DummyEventTestingClass methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/4/2015 11:03'!
lorem! !

!DummyEventTestingClass methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/4/2015 11:06'!
methodExecution

	self lorem ipsum foo bar! !

!DummyEventTestingClass methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/7/2015 12:45'!
msgReceive

	^ self lorem ipsum foo bar! !

!DummyEventTestingClass methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/7/2015 13:01'!
msgSend

	^ self lorem ipsum foo bar! !

!DummyEventTestingClass methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/7/2015 14:33'!
objectCreation

	"the new method on the other side will be intercessed"! !

!DummyEventTestingClass methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/4/2015 11:07'!
passedAsArg

	^ self foo: DummyEventTestingClass new! !

!DummyEventTestingClass methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/4/2015 11:01'!
readIV

	^ anIv ! !

!DummyEventTestingClass methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/4/2015 11:07'!
return

	^ 3! !

!DummyEventTestingClass methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/4/2015 11:08'!
returned: anIntercessedObject

	^ anIntercessedObject ! !

!DummyEventTestingClass methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/4/2015 11:08'!
stored: anIntercessedObject

	anIv := anIntercessedObject ! !

!DummyEventTestingClass methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/7/2015 17:12'!
tempRead

	|t|
	
	t := 3.
	^ t + 2! !

!DummyEventTestingClass methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/4/2015 11:10'!
tempWrite

	|t|
	
	t := 3.
	t + 2! !

!DummyEventTestingClass methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/7/2015 12:15'!
writeIV

	^ anIv := 3 ! !

Object subclass: #Event
	uses: TRBProgramNodeVisitor
	instanceVariableNames: 'link'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

Event class
	uses: TRBProgramNodeVisitor classTrait
	instanceVariableNames: 'default'!

Event class
	uses: TRBProgramNodeVisitor classTrait
	instanceVariableNames: 'default'!

!Event methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 14:35'!
annotateMethod: aMethod withLink: aMetaLink 

	link := aMetaLink.
	self visitNode: aMethod ast! !

!Event methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/29/2015 15:36'!
resolveScopeFor: aTarget

	self subclassResponsibility ! !

!Event methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 20:08'!
scope

	self subclassResponsibility ! !

Event subclass: #MultiScopedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!MultiScopedEvent methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 20:11'!
scope

	^ MultiScoped! !

MultiScopedEvent subclass: #RealMultiScoped
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

RealMultiScoped subclass: #PassedAsArg
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!PassedAsArg methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 20:04'!
visitMessageNode: aMessageNode 
	aMessageNode link: link.
	^ super visitMessageNode: aMessageNode.! !

!RealMultiScoped methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/29/2015 16:01'!
resolveScopeFor: aTarget

	aTarget realMultiScopedEvent: self! !

!RealMultiScoped methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/29/2015 15:59'!
scope

	^ RealMultiScope ! !

RealMultiScoped subclass: #Returned
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!Returned methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 20:04'!
visitReturnNode: aReturnNode 
	aReturnNode link: link.
	^ super visitReturnNode: aReturnNode.! !

RealMultiScoped subclass: #Stored
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!Stored methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/6/2015 11:03'!
visitAssignmentNode: anAssignmentNode
	anAssignmentNode link: link.
	^ super visitAssignmentNode: anAssignmentNode.! !

!Stored methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 12:26'!
visitStoreIntoTempNode: aNode
	aNode link: link.
	^ super visitStoreIntoTempNode: link.! !

MultiScopedEvent subclass: #SimulatedMultiScoped
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

SimulatedMultiScoped subclass: #MSGReceive
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!MSGReceive methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/7/2015 15:21'!
visitMethodNode: aMethodNode 
	aMethodNode link: link.
	^ super visitMethodNode: aMethodNode.! !

SimulatedMultiScoped subclass: #ObjectCreation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!ObjectCreation methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 20:03'!
visitMethodNode: aMethodNode 
	aMethodNode link: link.
	^ super visitMethodNode: aMethodNode.! !

!SimulatedMultiScoped methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/29/2015 16:01'!
resolveScopeFor: aTarget

	aTarget simulatedMultiScopedEvent: self! !

!SimulatedMultiScoped methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/29/2015 15:59'!
scope

	^ SimulatedMultiScope ! !

Event subclass: #SingleScopedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

SingleScopedEvent subclass: #GlobalRead
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!GlobalRead methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 14:35'!
visitGlobalNode: aGlobalNode
	aGlobalNode link: link.
	^ super visitVariableNode: aGlobalNode.! !

SingleScopedEvent subclass: #IVRead
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!IVRead methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/6/2015 11:30'!
visitVariableNode: aVariableNode
	((aVariableNode isInstance) & (aVariableNode parent ~= AssignmentNode)) "read" 
		ifTrue: [ aVariableNode link: link ].
	^ super visitVariableNode: aVariableNode.! !

SingleScopedEvent subclass: #IVWrite
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!IVWrite methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/6/2015 11:32'!
visitAssignmentNode: anAssignmentNode
	((anAssignmentNode variable isInstance)) "iv" 
		ifTrue: [ anAssignmentNode link: link ].
	^ super visitAssignmentNode: anAssignmentNode.! !

SingleScopedEvent subclass: #LiteralRead
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!LiteralRead methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/7/2015 12:32'!
visitLiteralNode: aLiteralNode

	aLiteralNode link: link.
	^ super visitVariableNode: aLiteralNode.! !

SingleScopedEvent subclass: #MSGSend
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!MSGSend methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 18:14'!
visitMessageNode: aMessageNode 
	aMessageNode link: link.
	^ super visitMessageNode: aMessageNode.! !

SingleScopedEvent subclass: #MethodExecution
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!MethodExecution methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 18:36'!
visitMethodNode: aMethodNode 
	aMethodNode link: link.
	^ super visitMethodNode: aMethodNode.! !

SingleScopedEvent subclass: #Return
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!Return methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 18:38'!
visitReturnNode: aReturnNode 

		aReturnNode link: link.
		^ super visitReturnNode: aReturnNode.! !

!SingleScopedEvent methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/29/2015 15:36'!
resolveScopeFor: aTarget

	aTarget singleScopedEvent: self.! !

!SingleScopedEvent methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 20:11'!
scope

	^ SingleScoped! !

SingleScopedEvent subclass: #TempRead
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!TempRead methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/6/2015 11:33'!
visitTemporaryNode: aNode 
	"Sent *each time* a temporary node is found"
	((aNode parent ~= AssignmentNode)) "read" 
		ifTrue: [ aNode link: link ].
	^ super visitTemporaryNode: aNode.! !

SingleScopedEvent subclass: #TempWrite
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!TempWrite methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/6/2015 12:23'!
visitAssignmentNode: anAssignmentNode
	((anAssignmentNode variable isTemp)) "iv" 
		ifTrue: [ anAssignmentNode link: link ].
	^ super visitAssignmentNode: anAssignmentNode.! !

!TempWrite methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/6/2015 11:34'!
visitStoreIntoTempNode: aNode
	"this is never called -- is done through assignment visit and checking"
	aNode link: link.
	^ super visitStoreIntoTempNode: aNode.! !

Object subclass: #MetaAction
	instanceVariableNames: 'blockClosure'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Conditions-Actions'!

MetaAction subclass: #FrameworkMetaAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Conditions-Actions'!

MetaAction subclass: #UserMetaAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Conditions-Actions'!

Object subclass: #MetaCondition
	instanceVariableNames: 'blockClosure'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Conditions-Actions'!

MetaCondition subclass: #FrameworkMetaCondition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Conditions-Actions'!

MetaCondition subclass: #InstallationMetaCondition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Conditions-Actions'!

MetaCondition subclass: #UserMetaCondition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Conditions-Actions'!

Object subclass: #Mode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

Mode subclass: #Scope
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

Scope subclass: #MultiScoped
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

MultiScoped subclass: #RealMultiScope
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

MultiScoped subclass: #SimulatedMultiScope
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

Scope subclass: #SingleScoped
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

SingleScoped subclass: #LexicallyScoped
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

SingleScoped subclass: #RunTimeScoped
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

Mode subclass: #Semantics
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

!Semantics commentStamp: 'NickPapoulias 7/23/2015 19:16' prior: 0!
semantics of hierarchy and reification!

Semantics subclass: #Hierarchy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

Hierarchy subclass: #Flat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

Hierarchy subclass: #Inheritance
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

Semantics subclass: #Reification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

Reification subclass: #Entity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

Reification subclass: #Instance
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

Object subclass: #RTVarAnalysis
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Case-Study'!

Object subclass: #Reflecto
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Graph-Points'!

!Reflecto class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/3/2015 11:39'!
on: anEntity as: semanticsPair for: anEvent limitedTo: installationCondition when: userCondition do: userAction

	"single methods can be treated through class -- same for contexts"
	
	| reification hierarchy target |
	
	reification := semanticsPair key. "Instance -> Flat etc"
	hierarchy  := semanticsPair value.
	
	target := (reification = Instance) "This can also be done with Target on:given: replicating here for clarity" 
		ifTrue: [ ^ ObjectTarget new target: anEntity  ] "treat as object"
		ifFalse: [ ^ (Target resolve: anEntity) new target: anEntity ]. "treat as entity -- which also includes objects"
	
	target 
		setScopeFor: anEvent; "major scope and sub scope"
		calculateAffectedMethodsGiven: hierarchy; 
		limitAffectedMethodsGiven: installationCondition.
	
	target affectedMethods 
		do: [: method |  anEvent annotateMethod: method. "the event should know" ]
	 	! !

!Reflecto class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/24/2015 10:18'!
on: anEntity for: anEvent limitedTo: installationCondition when: userCondition do: userAction

	"installation condition can be method | class | package"
	
	| defaultSemanticPair |
	defaultSemanticPair := anEntity defaultSemanticPair.! !

!Reflecto class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/24/2015 10:47'!
on: anEntity for: anEvent when: userCondition do: userAction

	"installation condition can be method | class | package"
	
	| defaultSemanticPair |
	defaultSemanticPair := anEntity defaultSemanticPair.! !

Reflecto subclass: #ReflectoGram
	instanceVariableNames: 'target event metaConditionGroup metaActionGroup trace points'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Graph-Points'!

Reflecto subclass: #ReflectoPoint
	instanceVariableNames: 'graph reifications time level'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Graph-Points'!

Object subclass: #ReflectoGramVisualization
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Graph-Points'!

Object subclass: #Reifications
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Graph-Points'!

Object subclass: #Target
	instanceVariableNames: 'target scope reification hierarchy affectedMethods affectedClasses installCondition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Targets'!

Target class
	instanceVariableNames: 'resolveDict'!

Target class
	instanceVariableNames: 'resolveDict'!

Target subclass: #ClassTarget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Targets'!

!ClassTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/3/2015 12:20'!
defaultAffectedClasses

	^ {target} asOrderedCollection ! !

!ClassTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/29/2015 15:38'!
singleScopedEvent: anEvent

	scope := LexicallyScoped ! !

Target subclass: #ContextTarget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Targets'!

!ContextTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/3/2015 12:04'!
calculateAffectedMethodsGiven: anHierarchy

	affectedMethods := {target method} asOrderedCollection! !

!ContextTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/3/2015 12:20'!
defaultAffectedClasses

	^ {target method class} asOrderedCollection
	! !

!ContextTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/3/2015 12:03'!
defaultAffectedHierarchy

	self shouldNotImplement 
	! !

!ContextTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/29/2015 16:21'!
realMultiScopedEvent: anEvent

	self shouldNotImplement ! !

!ContextTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/29/2015 16:21'!
simulatedMultiScopedEvent: anEvent

	self shouldNotImplement ! !

!ContextTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/29/2015 15:40'!
singleScopedEvent: anEvent

	scope := RunTimeScoped ! !

Target subclass: #ImageTarget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Targets'!

!ImageTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/3/2015 12:21'!
defaultAffectedClasses

	^ ProtoObject allSubclasses! !

!ImageTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/3/2015 12:09'!
defaultAffectedHierarchy
	
	^ ProtoObject allSubclasses! !

!ImageTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/29/2015 15:41'!
singleScopedEvent: anEvent

	scope := LexicallyScoped ! !

Target subclass: #MethodTarget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Targets'!

!MethodTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/3/2015 12:10'!
calculateAffectedMethodsGiven: anHierarchy

	affectedMethods := {target} asOrderedCollection! !

!MethodTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/3/2015 12:18'!
defaultAffectedClasses
	
	^ target methodClass! !

!MethodTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/3/2015 12:10'!
defaultAffectedHierarchy
	
	self shouldNotImplement 
	! !

!MethodTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/29/2015 16:22'!
realMultiScopedEvent: anEvent

	self shouldNotImplement ! !

!MethodTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/29/2015 16:22'!
simulatedMultiScopedEvent: anEvent

	self shouldNotImplement ! !

!MethodTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/29/2015 15:41'!
singleScopedEvent: anEvent

	scope := LexicallyScoped ! !

Target subclass: #ObjectTarget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Targets'!

!ObjectTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/3/2015 12:21'!
defaultAffectedClasses
	
	^ {target class} asOrderedCollection ! !

!ObjectTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/29/2015 15:42'!
singleScopedEvent: anEvent

	scope := RunTimeScoped ! !

Target subclass: #PackageTarget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Targets'!

!PackageTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/3/2015 12:24'!
defaultAffectedClasses
	
	^ target classes! !

!PackageTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/29/2015 15:42'!
singleScopedEvent: anEvent

	scope := LexicallyScoped ! !

Target subclass: #ProcessTarget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Targets'!

!ProcessTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/3/2015 12:33'!
calculateAffectedMethodsGiven: anHierarchy

	"start with the suspended context and then just intercess on return and on send"

	target suspend.
	affectedMethods := {target suspendedContext method} asOrderedCollection! !

!ProcessTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/3/2015 12:28'!
defaultAffectedClasses

	target suspend.
	^ {target suspendedContext method methodClass} asOrderedCollection ! !

!ProcessTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/3/2015 12:29'!
defaultAffectedHierarchy

	self shouldNotImplement ! !

!ProcessTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/29/2015 16:22'!
realMultiScopedEvent: anEvent

	self shouldNotImplement ! !

!ProcessTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/29/2015 16:22'!
simulatedMultiScopedEvent: anEvent

	self shouldNotImplement ! !

!ProcessTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/29/2015 15:43'!
singleScopedEvent: anEvent

	scope := RunTimeScoped ! !

!Target class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/25/2015 13:09'!
on: anEntity

	^ self on: anEntity given: Entity! !

!Target class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/25/2015 13:08'!
on: anEntity given: reification
	
	(reification = Instance) 
		ifTrue: [ ^ ObjectTarget new target: anEntity  ] "treat as object"
		ifFalse: [ ^ (Target resolve: anEntity) new target: anEntity ]. "treat as entity -- which also includes objects"	! !

!Target class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/25/2015 13:09'!
resolve: anEntity
	
	self resolveDict keysAndValuesDo: [ :classKey : targetClass |
		(anEntity class isKindOf: classKey) ifTrue: [ ^ targetClass ]		
	].

	^ ObjectTarget
	! !

!Target class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/25/2015 13:03'!
resolveDict
	
	^ resolveDict ifNil: [resolveDict := {Class -> ClassTarget . Context -> ContextTarget . SystemDictionary -> ImageTarget . CompiledMethod ->MethodTarget .RPackage -> PackageTarget . Process -> ProcessTarget} asDict]  
! !

!Target methodsFor: 'accessing' stamp: 'NickPapoulias 8/3/2015 12:17'!
calculateAffectedClassesGiven: anHierarchy

	hierarchy := anHierarchy
	
	anHierarchy = Flat
		ifTrue: [ affectedClasses := self defaultAffectedClasses ]
		ifFalse: [ affectedClasses := self defaultAffectedHierarchy ]! !

!Target methodsFor: 'accessing' stamp: 'NickPapoulias 8/3/2015 11:47'!
calculateAffectedMethodsGiven: anHierarchy

	self calculateAffectedClassesGiven: anHierarchy.
	affectedMethods := affectedClasses flatCollect: [ :class | class methodDict values ]! !

!Target methodsFor: 'accessing' stamp: 'NickPapoulias 8/3/2015 12:18'!
defaultAffectedClasses

	self subclassResponsibility ! !

!Target methodsFor: 'accessing' stamp: 'NickPapoulias 8/3/2015 12:20'!
defaultAffectedHierarchy

	| nextClass hierarchyCollection |
	self defaultAffectedClasses do: [ :aClass | 
		nextClass := aClass.
		hierarchyCollection := OrderedCollection new.
		[ nextClass ] whileNotNil: [ hierarchyCollection add: nextClass. nextClass := nextClass superclass ].
	].
	^ hierarchyCollection! !

!Target methodsFor: 'accessing' stamp: 'NickPapoulias 8/3/2015 12:38'!
limitAffectedMethodsGiven: installationCondition

	installCondition := installationCondition.
	affectedMethods := affectedMethods select: installCondition.
	affectedClasses := (affectedMethods collect: [ :method | method methodClass ]) asSet.! !

!Target methodsFor: 'accessing' stamp: 'NickPapoulias 7/29/2015 16:02'!
realMultiScopedEvent: anEvent

	scope := anEvent scope! !

!Target methodsFor: 'accessing' stamp: 'NickPapoulias 7/29/2015 15:34'!
setScopeFor: anEvent

	anEvent resolveScopeFor: self class.! !

!Target methodsFor: 'accessing' stamp: 'NickPapoulias 7/29/2015 16:02'!
simulatedMultiScopedEvent: anEvent

	scope := anEvent scope! !

!Target methodsFor: 'accessing' stamp: 'NickPapoulias 7/29/2015 15:37'!
singleScopedEvent: anEvent

	self subclassResponsibility ! !

!Target methodsFor: 'accessing' stamp: 'NickPapoulias 7/23/2015 16:36'!
target
	^ target! !

!Target methodsFor: 'accessing' stamp: 'NickPapoulias 7/23/2015 16:36'!
target: anObject
	target := anObject! !

Object subclass: #View
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Case-Study'!

Object subclass: #WebApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Case-Study'!
